//
// Copyright (C) 2004 Andras Varga
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#include "PositionTableforMobilityCam.h"


std::vector<IPvXAddress> PositionTableforMobilityCam::getAddresses()  {
    std::vector<IPvXAddress> addresses;
    for (AddressToPositionMap::const_iterator it = addressToPositionMap.begin(); it != addressToPositionMap.end(); it++)
        addresses.push_back(it->first);
    return addresses;
}

int PositionTableforMobilityCam::getLengthOfPositionTable()
{
    int i=0;
    std::vector<IPvXAddress> addresses;
    for (AddressToPositionMap::const_iterator it = addressToPositionMap.begin(); it != addressToPositionMap.end(); it++)
        i++;
    return i;

}

bool PositionTableforMobilityCam::hasPosition( IPvXAddress address)  {
    AddressToPositionMap::const_iterator it = addressToPositionMap.find(address);
    return it != addressToPositionMap.end();
}

Coord PositionTableforMobilityCam::getPosition( IPvXAddress address)  {
    AddressToPositionMap::const_iterator it = addressToPositionMap.find(address);
    if (it == addressToPositionMap.end())
        return Coord(NaN, NaN, NaN);
    else
        return it->second.position;
}
// orginal programm
//void PositionTableforMobilityCam::setPosition( IPvXAddress address,  Coord position, Coord speed, Coord heading) {
//    ASSERT(!address.isUnspecified());
//    addressToPositionMap[address] = MobilityInformation(simTime(),heading, position,speed);
//}

void PositionTableforMobilityCam::setPosition( IPvXAddress address,  Coord position, Coord speed) {
//    ASSERT(!address.isUnspecified());
    addressToPositionMap[address] = MobilityInformation(simTime(), position,speed);
}
simtime_t PositionTableforMobilityCam::getCreateTime( IPvXAddress address) {
    AddressToPositionMap::const_iterator it = addressToPositionMap.find(address);
//    if (it == addressToPositionMap.end())
//               return SimTime::getMaxTime();
//           else
//               return it->second.createTime;
        if (it == addressToPositionMap.end())
            return 0;
        else
            return it->second.createTime;
}
Coord PositionTableforMobilityCam::getSpeed( IPvXAddress address)  {

    AddressToPositionMap::const_iterator it = addressToPositionMap.find(address);
    if (it == addressToPositionMap.end())
        return Coord(NaN, NaN, NaN);
    else
        return it->second.speed;
}

void PositionTableforMobilityCam::setSpeed( IPvXAddress address,  Coord position, Coord speed) {
//    ASSERT(!address.isUnspecified());
    addressToPositionMap[address] = MobilityInformation(simTime(), position,speed);
}

//void PositionTableforMobilityCam::setSpeed( IPvXAddress address,  Coord  speed) {
////   ASSERT(!address.isUnspecified());
//    addressToPositionMap[address].speed = speed;
//
//}

//void PositionTableforMobilityCam::setHeading(IPvXAddress  address,  Coord  heading)
//{
////    ASSERT(!address.isUnspecified());
//    addressToPositionMap[address].heading = heading;
//}
//
//
//Coord PositionTableforMobilityCam::getHeading( IPvXAddress  address)
//{
//
//        AddressToPositionMap::const_iterator it = addressToPositionMap.find(address);
//        if (it == addressToPositionMap.end())
//            return Coord(NaN, NaN, NaN);
//        else
//            return it->second.heading;
// }

void PositionTableforMobilityCam::setHeading(IPvXAddress  address,  double  heading)
{
//    ASSERT(!address.isUnspecified());
    addressToPositionMap[address].heading = heading;
}


double PositionTableforMobilityCam::getHeading( IPvXAddress  address)
{

        AddressToPositionMap::const_iterator it = addressToPositionMap.find(address);
        if (it == addressToPositionMap.end())
            return 0;
        else
            return it->second.heading;
 }


void PositionTableforMobilityCam::removePosition( IPvXAddress address) {
    AddressToPositionMap::iterator it = addressToPositionMap.find(address);
    addressToPositionMap.erase(it);
}



void PositionTableforMobilityCam::removeOldPositions(simtime_t timestamp) {
    for (AddressToPositionMap::const_iterator it = addressToPositionMap.begin(); it != addressToPositionMap.end();)
        if (it->second.createTime <= timestamp) {
            addressToPositionMap.erase(it);
            it++;
        }
        else
            it++;
}

void PositionTableforMobilityCam::clear() {
    addressToPositionMap.clear();
}

simtime_t PositionTableforMobilityCam::getOldestPosition()  {
    simtime_t oldestPosition = SimTime::getMaxTime();
    for (AddressToPositionMap::const_iterator it = addressToPositionMap.begin(); it != addressToPositionMap.end(); it++) {
         simtime_t time = it->second.createTime;
        if (time < oldestPosition)
            oldestPosition = time;
    }
    return oldestPosition;
}
