/*
 * PositionTableforMobilityCam.h
 *
 *  Created on: Nov 29, 2016
 *      Author: tongxinglu
 */


#ifndef POSITIONTABLEFORMOBILITYCAM_H_
#define POSITIONTABLEFORMOBILITYCAM_H_



#include <vector>
#include <map>
#include "INETDefs.h"
#include "IPvXAddress.h"
#include "Coord.h"

 static double   NaN = 0.0 / 0.0;

/**
 * This class provides a mapping between node addresses and their positions.
 */
 class MobilityInformation {
     public:
     MobilityInformation(){};

//     ~MobilityInformation(){};
     public:
            Coord speed;
            Coord position;
            double heading;
            simtime_t createTime;
            MobilityInformation(simtime_t createTime, Coord position=Coord(NaN, NaN, NaN), Coord speed=Coord(NaN, NaN, NaN), double heading=0.0)
            {
                        this->createTime=createTime;
                        this->position=position;
                        this->speed=speed;
                        this->heading=heading;

             }

 };

class PositionTableforMobilityCam {
    private:
        typedef std::map<IPvXAddress, MobilityInformation> AddressToPositionMap;
        AddressToPositionMap addressToPositionMap;

    public:
        PositionTableforMobilityCam() { }

        std::vector<IPvXAddress> getAddresses() ;
        int getLengthOfPositionTable();


        void setHeading(IPvXAddress  address,  double  heading);
        double getHeading(IPvXAddress  address);


           bool hasPosition( IPvXAddress  address) ;
           Coord getPosition( IPvXAddress  address) ;
//           void setPosition( IPvXAddress address,  Coord position, Coord speed, Coord heading);
           void setPosition( IPvXAddress address,  Coord position, Coord speed);
//           void setSpeed( IPvXAddress  address,  Coord  speed);
          void setSpeed( IPvXAddress address,  Coord position, Coord speed);
           Coord getSpeed( IPvXAddress  address) ;
           simtime_t getCreateTime( IPvXAddress  address) ;

           void setHostName( IPvXAddress  address,  std::string hostname);
           std::string getHostName( IPvXAddress  address) ;

           void setIfCoordinator( IPvXAddress address,  bool iscoordinator);
           bool getIfCoordinator( IPvXAddress  address) ;


           void removePosition( IPvXAddress  address);
           void removeOldPositions(simtime_t timestamp);

           void clear();

           simtime_t getOldestPosition() ;
};



#endif /* POSITIONTABLEFORMOBILITYCAM_H_ */
