//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 



#ifndef _UDPBASICAPPCAM_H_
#define _UDPBASICAPPCAM_H_

#include <omnetpp.h>
#include <vector>

#include "INETDefs.h"

#include "ApplicationBase.h"
#include "UDPSocket.h"
#include "UDPBasicApp.h"
#include <RouteInterface.h>
#include "IMobility.h"
#include "csimplemodule.h"
#include <cmessage.h>
#include <RouteInterface.h>
#include "IMobility.h"
#include "IRoutingTable.h"
#include "NodeStatus.h"
#include "IInterfaceTable.h"
#include "ModuleAccess.h"
#include "basicCamContainer_m.h"
#include "PositionTableforMobilityCam.h"
#include "UDPPacket.h"
#include "UDPControlInfo_m.h"
#include "UDPBasicBurst.h"


/**
 * TODO - Generated class
 */
//INET_API
class  INET_API UDPBasicAppCam : public UDPBasicApp //,public UDPSendCommand
{


private:
    cMessage * camTimer;

    UDPSocket socket;

    PositionTableforMobilityCam  positionTableforMobilityCam;

protected:

   // enum GeneratorDenm { Denm_Trigger = 1, Denm_Update, Denm_Receive};

   enum SelfMsgKinds{ START = 1, SEND, STOP};

   int destAddrRNG;


   IPvXAddress destAddr;

   simtime_t camInterval;

   simtime_t T_GenCamMin;
   simtime_t  T_GenCamMax;
   double speedThreshold;
   double positionThreshold;

   static simsignal_t revdCamSignal;
   static simsignal_t sentCamSignal;

   static simsignal_t rcvdPkSignal;

   int localPort, destPort;
   std::vector<IPvXAddress> destAddresses;
//   std::vector<IPvXAddress> localAddress;
   simtime_t startTime;
   simtime_t stopTime;
   cMessage *selfMsg;
   IPvXAddress address;

   int outputInterface;
   std::vector<int> outputInterfaceMulticastBroadcast;



   basicCamContainer * mcam;
   PDUHeader * CreatePduHeader();

   RouteInterface routeInterface;

   cModule * host;
   NodeStatus * nodeStatus;
   IMobility * mobility;

   IRoutingTable * routingTable;

   int sockId;
//   int outInterfaceId;


   // statistics
   int numCamSent;
   int numCamReceived;

//   static simsignal_t sentPkSignal;
//   static simsignal_t rcvdPkSignal;

   // chooses random destination address
   virtual IPvXAddress chooseDestAddr();
   virtual void processPacket(cPacket *msg);
  virtual void setSocketOptions();


   IPvXAddress getSelfAddress() const;
   Coord getSelfSpeed();
   basicCamContainer * carCamGeneration(cModule *host, IMobility *mobility);

 public:

   virtual void sendPacket();
   UDPBasicAppCam();
   ~UDPBasicAppCam();

 protected:
   virtual int numInitStages() const { return 4; }
   virtual void initialize(int stage);
//   virtual void handleMessageWhenUp(cMessage *msg);
   virtual void finish();
   virtual void handleMessage(cMessage * msg);

   virtual void processStart();
   virtual void processSend();
   virtual void processStop();

   virtual bool handleNodeStart(IDoneCallback *doneCallback);
   virtual bool handleNodeShutdown(IDoneCallback *doneCallback);
   virtual void handleNodeCrash();

     void scheduleCamTimer();
    void CheckCamConditionTimer();



   bool checkSpeed(Coord curSpeed,Coord preSpeed);
   bool checkPosition( Coord curPosition,Coord prePosition);
   bool checkHeading( Coord curPosition,Coord prePosition);
   double getVectorAngle(Coord vector);
   double adjustVectorAngle(double angle);
   void CheckCamCondition( IPvXAddress selfAddress);

    void  sendCam( IPvXAddress selfAddress );

 protected:

    cMessage * appDenm_trigger;
    cMessage * appDenm_update;

   virtual void initialConfiguration();
   bool sendBroadcast(const IPvXAddress &dest, cPacket *pkt);


};

#endif

